% MTODO 3 
% TEST 3-2 Y TEST 3-3. 
%
% La referencia utilizada ha sido:
%
%	J. S. Cnovas, A. Guillamn
%	PERMUTATIONS AND TIME SERIES ANALYSIS
%	Chaos 19 (2009), 043103

function valores_t2yt3=calcula_EC_CyG2y3(serie_temp,m)

serie=serie_temp; % serie temporal
T=length(serie); % nmero de elementos de la serie
   
Tventana=m*factorial(m);
Nventanas=fix(T/Tventana);

k=Tventana/m; % nmero de tramos en que se divide cada ventana
Nmax_permutaciones_diferentes=min(fix(k),factorial(m)); % nmero mximo de permutaciones diferentes en cada ventana

v_Npermutaciones_diferentes=zeros(Nventanas,1);

for cont1=1:Nventanas
    
    ventana=serie((cont1-1)*Tventana+1:cont1*Tventana);
    M_permutaciones=zeros(factorial(m),m);

    trozo_ventana1=ventana(1:m);
    [trozo_ordenado1,permutacion1]=sort(trozo_ventana1);
    M_permutaciones(1,:)=permutacion1;
    Npermutaciones_diferentes=1;
    
    for cont2=m+1:m:Tventana-m+1
    
        trozo_ventana=ventana(cont2:cont2+m-1);
        [trozo_ordenado,permutacion]=sort(trozo_ventana);
        
        testigo=1;
    
        for cont3=1:Npermutaciones_diferentes
        
            if isequal(M_permutaciones(cont3,:),permutacion)
            
                testigo=0;
                break            
            
            end
        
        end
    
        if testigo
        
        Npermutaciones_diferentes=Npermutaciones_diferentes+1;    
        M_permutaciones(Npermutaciones_diferentes,:)=permutacion;
    
        end
    
    end

    v_Npermutaciones_diferentes(cont1)=Npermutaciones_diferentes;

end

probabilidad=load(strcat('VPROB_T',num2str(Tventana),'m',num2str(m),'.txt'));
probabilidad=probabilidad';

Estadistico_contraste_t2=0; % estadistco de contraste del test 2

for cont4=1:Nmax_permutaciones_diferentes
    
    fi=0;
    ei=Nventanas*probabilidad(cont4);
    
    for cont5=1:Nventanas
        
        if v_Npermutaciones_diferentes(cont5)==cont4
            
            fi=fi+1;
            
        end
        
    end
    
    Estadistico_contraste_t2=Estadistico_contraste_t2+((fi-ei)^2/ei);
    
end

suma_FW=0;
FW=zeros(Nmax_permutaciones_diferentes,1); % funcin de distribucin terica

for cont6=1:Nmax_permutaciones_diferentes
    
    suma_FW=suma_FW+probabilidad(cont6);
    FW(cont6)=suma_FW;
    
end

auxiliar_Fn=zeros(Nmax_permutaciones_diferentes,1);
Fn=zeros(Nmax_permutaciones_diferentes,1); % funcin de distribucin emprica

for cont7=1:Nventanas
    
    posicion=v_Npermutaciones_diferentes(cont7);
    auxiliar_Fn(posicion)=auxiliar_Fn(posicion)+1/Nventanas;
    
end

Fn(1)=auxiliar_Fn(1);

for cont8=2:Nmax_permutaciones_diferentes
    
    Fn(cont8)=Fn(cont8-1)+auxiliar_Fn(cont8);
    
end

Dn=max(abs(Fn-FW)); % distancia mxima entre Fn y FW
Estadistico_contraste_t3=sqrt(Nventanas)*Dn; % estadstico de contraste del test 3

suma_pValor=0;

for cont9=1:10
    
    suma_pValor=suma_pValor+(-1)^(cont9+1)*exp(-2*(cont9*Estadistico_contraste_t3)^2);
    
end

pValor_t3=2*suma_pValor; % p-valor

valores_t2yt3=[Estadistico_contraste_t2,pValor_t3];
