(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     12673,        311]
NotebookOptionsPosition[     12388,        297]
NotebookOutlinePosition[     12731,        312]
CellTagsIndexPosition[     12688,        309]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{
    "C\[AAcute]lculo", " ", "de", " ", "los", " ", "valores", " ", "de", " ", 
     "los", " ", "n\[UAcute]meros", " ", "de", " ", "Stirling", " ", "de", 
     " ", "segunda", " ", "especie"}], ",", " ", 
    RowBox[{
    "de", " ", "la", " ", "funci\[OAcute]n", " ", "de", " ", "probabilidad", 
     " ", "y", " ", "de", " ", "la", " ", "funci\[OAcute]n", " ", "de", " ", 
     RowBox[{"distribuci\[OAcute]n", "."}]}]}], "*)"}], "\[IndentingNewLine]",
   "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"ClearAll", "[", 
    RowBox[{
    "T", ",", "m", ",", "Nconfianza", ",", "k", ",", "tope", ",", "prob", ",",
      "vectorStirlingS2", ",", "f", ",", "vectorProbabilidad", ",", "g", ",", 
     "t", ",", "vectorFDistribucion", ",", "h", ",", "suma", ",", 
     "NconfianzaReal", ",", "Vcritico"}], "]"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"T", "=", "12"}], ";"}], " ", 
   RowBox[{"(*", 
    RowBox[{"tama\[NTilde]o", " ", "de", " ", "la", " ", "serie"}], "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"m", "=", "4"}], ";"}], " ", 
   RowBox[{"(*", 
    RowBox[{"dimensi\[OAcute]n", " ", "de", " ", "inmersi\[OAcute]n"}], 
    "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Nconfianza", "=", "95"}], ";"}], " ", 
   RowBox[{"(*", 
    RowBox[{"nivel", " ", "de", " ", "confianza"}], "*)"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"k", "=", 
     RowBox[{"IntegerPart", "[", 
      RowBox[{"T", "/", "m"}], "]"}]}], ";"}], " ", 
   RowBox[{"(*", 
    RowBox[{
    "n\[UAcute]mero", " ", "de", " ", "ventanas", " ", "deslizantes"}], 
    "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"tope", "=", 
     RowBox[{"Min", "[", 
      RowBox[{
       RowBox[{"m", "!"}], ",", "k"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"prob", "[", 
      RowBox[{"k_", ",", "m_", ",", "t_"}], "]"}], ":=", 
     RowBox[{
      RowBox[{"StirlingS2", "[", 
       RowBox[{"k", ",", "t"}], "]"}], "*", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{"m", "!"}], ")"}], "!"}], "/", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"m", "!"}], "-", "t"}], ")"}], "!"}]}], ")"}], "*", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"1", "/", 
         RowBox[{"m", "!"}]}], ")"}], "^", "k"}]}]}], ";"}], " ", 
   RowBox[{"(*", 
    RowBox[{"funci\[OAcute]n", " ", "de", " ", "probabilidad"}], "*)"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"vectorStirlingS2", "=", 
     RowBox[{"Array", "[", 
      RowBox[{"f", ",", 
       RowBox[{"{", "tope", "}"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"vectorProbabilidad", "=", 
     RowBox[{"Array", "[", 
      RowBox[{"g", ",", 
       RowBox[{"{", "tope", "}"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"For", "[", 
     RowBox[{
      RowBox[{"t", "=", "1"}], ",", 
      RowBox[{"t", "\[LessSlantEqual]", "tope"}], ",", 
      RowBox[{"t", "++"}], ",", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"f", "[", "t", "]"}], "=", 
        RowBox[{"StirlingS2", "[", 
         RowBox[{"k", ",", "t"}], "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"g", "[", "t", "]"}], "=", 
        RowBox[{"prob", "[", 
         RowBox[{"k", ",", "m", ",", "t"}], "]"}]}], ";"}]}], 
     "\[IndentingNewLine]", "]"}], ";"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{
   "(", "\"\<Vector de n\[UAcute]meros de Stirling de segunda especie\>\"", 
    ")"}], "\[IndentingNewLine]", "vectorStirlingS2", "\[IndentingNewLine]", 
   RowBox[{
   "(", "\"\<Vector de los valores de la funci\[OAcute]n de probabilidad\>\"",
     ")"}], "\[IndentingNewLine]", "vectorProbabilidad", 
   "\[IndentingNewLine]", 
   RowBox[{"N", "[", "vectorProbabilidad", "]"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"vectorFDistribucion", "=", 
     RowBox[{"Array", "[", 
      RowBox[{"h", ",", 
       RowBox[{"{", "tope", "}"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"h", "[", "1", "]"}], "=", 
     RowBox[{"g", "[", "1", "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"For", "[", 
     RowBox[{
      RowBox[{"t", "=", "2"}], ",", 
      RowBox[{"t", "\[LessSlantEqual]", "tope"}], ",", 
      RowBox[{"t", "++"}], ",", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"h", "[", "t", "]"}], "=", 
        RowBox[{
         RowBox[{"h", "[", 
          RowBox[{"t", "-", "1"}], "]"}], "+", 
         RowBox[{"g", "[", "t", "]"}]}]}], ";"}]}], "\[IndentingNewLine]", 
     "]"}], ";"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
   "(", "\"\<Vector de los valores de la funci\[OAcute]n de distribuci\
\[OAcute]n\>\"", ")"}], "\[IndentingNewLine]", "vectorFDistribucion", 
   "\[IndentingNewLine]", 
   RowBox[{"N", "[", "vectorFDistribucion", "]"}]}]}]], "Input",
 CellChangeTimes->{{3.5399541071864223`*^9, 3.539954141254057*^9}, {
   3.5399541760454664`*^9, 3.53995423887739*^9}, {3.53995428294966*^9, 
   3.5399543708224144`*^9}, {3.5400361740170918`*^9, 3.540036188041517*^9}, {
   3.540036257648839*^9, 3.54003633795778*^9}, {3.5400363828234587`*^9, 
   3.540036511679685*^9}, {3.540036573876994*^9, 3.540036654841137*^9}, {
   3.540036695089207*^9, 3.540036780920558*^9}, {3.540036820123427*^9, 
   3.540036843398668*^9}, {3.5400368745519223`*^9, 3.5400369742672977`*^9}, {
   3.5400377729419003`*^9, 3.5400378147811737`*^9}, {3.5400379404081945`*^9, 
   3.540038029281551*^9}, {3.540038071854026*^9, 3.5400382182290826`*^9}, {
   3.540038252112342*^9, 3.540038259303955*^9}, {3.540040435928978*^9, 
   3.540040479577854*^9}, {3.540040526050336*^9, 3.540040526487137*^9}, {
   3.540040789066798*^9, 3.5400407932632055`*^9}, {3.5400453543174095`*^9, 
   3.540045364660228*^9}, {3.5400455032196712`*^9, 3.540045506994878*^9}, {
   3.540045549723353*^9, 3.5400455733885946`*^9}, {3.5400461499500074`*^9, 
   3.5400461554412165`*^9}, {3.540048604302318*^9, 3.540048604770319*^9}, {
   3.540049241813038*^9, 3.540049242390239*^9}, {3.5400515058606143`*^9, 
   3.5400515060478144`*^9}, 3.540051953581401*^9, {3.54005243123864*^9, 
   3.54005243162864*^9}, {3.5400528499589753`*^9, 3.540052850021375*^9}, {
   3.540053354807062*^9, 3.540053354869462*^9}, {3.540053733903328*^9, 
   3.540053734589729*^9}, {3.5401627232041025`*^9, 3.540162743047337*^9}, {
   3.540162825368682*^9, 3.5401630291362395`*^9}, {3.540163134108824*^9, 
   3.5401631343428245`*^9}, {3.5401631930145273`*^9, 3.540163193482528*^9}, 
   3.5401645949733896`*^9, {3.5403031762777205`*^9, 3.5403031888045425`*^9}, {
   3.540309843967678*^9, 3.540309862921712*^9}, {3.540309909409794*^9, 
   3.5403099132786007`*^9}, {3.540324894971795*^9, 3.5403249005878053`*^9}, {
   3.540375518106899*^9, 3.5403755192979665`*^9}, {3.540385746688526*^9, 
   3.5403857509629335`*^9}, {3.5523216554264364`*^9, 3.5523216554834394`*^9}, 
   3.552334080731374*^9, 3.5523351393017683`*^9, {3.552335301894758*^9, 
   3.5523353025407815`*^9}, 3.552336580230425*^9, {3.5523370490232983`*^9, 
   3.552337049079301*^9}, {3.5523374337674255`*^9, 3.552337434416463*^9}, {
   3.5523378890850596`*^9, 3.5523378897510977`*^9}, {3.552339073965651*^9, 
   3.552339074032655*^9}, {3.552339518909768*^9, 3.5523395189687715`*^9}, {
   3.5523397749267535`*^9, 3.5523397749947577`*^9}, {3.5526424324545403`*^9, 
   3.55264243251694*^9}, 3.5526660756498885`*^9, {3.55628559440774*^9, 
   3.556285598407969*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{"C\[AAcute]lculo", " ", "del", " ", "valor", " ", 
    RowBox[{"cr\[IAcute]tico", "."}]}], "*)"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"ClearAll", "[", 
    RowBox[{
    "T", ",", "m", ",", "Nconfianza", ",", "k", ",", "tope", ",", "prob", ",",
      "suma", ",", "t", ",", "NconfianzaReal", ",", "Vcritico"}], "]"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"T", "=", "360"}], ";"}], " ", 
   RowBox[{"(*", 
    RowBox[{"tama\[NTilde]o", " ", "de", " ", "la", " ", "serie"}], "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"m", "=", "4"}], ";"}], " ", 
   RowBox[{"(*", 
    RowBox[{"dimensi\[OAcute]n", " ", "de", " ", "inmersi\[OAcute]n"}], 
    "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Nconfianza", "=", "99"}], ";"}], " ", 
   RowBox[{"(*", 
    RowBox[{"nivel", " ", "de", " ", "confianza"}], "*)"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"k", "=", 
     RowBox[{"IntegerPart", "[", 
      RowBox[{"T", "/", "m"}], "]"}]}], ";"}], " ", 
   RowBox[{"(*", 
    RowBox[{
    "n\[UAcute]mero", " ", "de", " ", "ventanas", " ", "deslizantes"}], 
    "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"tope", "=", 
     RowBox[{"Min", "[", 
      RowBox[{
       RowBox[{"m", "!"}], ",", "k"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"prob", "[", 
      RowBox[{"k_", ",", "m_", ",", "t_"}], "]"}], ":=", 
     RowBox[{
      RowBox[{"StirlingS2", "[", 
       RowBox[{"k", ",", "t"}], "]"}], "*", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{"m", "!"}], ")"}], "!"}], "/", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"m", "!"}], "-", "t"}], ")"}], "!"}]}], ")"}], "*", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"1", "/", 
         RowBox[{"m", "!"}]}], ")"}], "^", "k"}]}]}], ";"}], " ", 
   RowBox[{"(*", 
    RowBox[{"funci\[OAcute]n", " ", "de", " ", "probabilidad"}], "*)"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"suma", "=", "0"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"For", " ", "[", 
     RowBox[{
      RowBox[{"t", "=", "tope"}], ",", 
      RowBox[{"t", "\[GreaterSlantEqual]", "1"}], ",", 
      RowBox[{"t", "--"}], ",", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"suma", "=", 
        RowBox[{"suma", "+", 
         RowBox[{"prob", "[", 
          RowBox[{"k", ",", "m", ",", "t"}], "]"}]}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"suma", "\[GreaterSlantEqual]", 
          RowBox[{"Nconfianza", "/", "100"}]}], ",", 
         RowBox[{"Break", "[", "]"}]}], "]"}]}]}], "\[IndentingNewLine]", 
     "]"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"NconfianzaReal", "=", 
     RowBox[{"100", "*", "suma"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Vcritico", "=", "t"}], ";"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{
   "(", "\"\<Valor cr\[IAcute]tico para el nivel de confianza fijado\>\"", 
    ")"}], "\[IndentingNewLine]", "Vcritico", "\[IndentingNewLine]", 
   RowBox[{"(", "\"\<Valor real del nivel de confianza\>\"", ")"}], 
   "\[IndentingNewLine]", 
   RowBox[{"N", "[", "NconfianzaReal", "]"}]}]}]], "Input",
 CellChangeTimes->{{3.5403099652266912`*^9, 3.5403099778315134`*^9}, {
  3.54032440241653*^9, 3.540324405817336*^9}, {3.5403244652222404`*^9, 
  3.540324501788705*^9}, {3.5403245523483934`*^9, 3.540324581614045*^9}, {
  3.5403756801731462`*^9, 3.5403756879685917`*^9}, {3.5551911512014513`*^9, 
  3.555191159750267*^9}, {3.555191285689288*^9, 3.5551913065309243`*^9}, {
  3.5551913504450016`*^9, 3.5551913803190536`*^9}, {3.55519141774352*^9, 
  3.555191626721487*^9}, {3.5551919979709387`*^9, 3.5551925024290247`*^9}, {
  3.55519256768394*^9, 3.5551928212155848`*^9}, {3.5551928563936467`*^9, 
  3.555192892866511*^9}, {3.556285613862853*^9, 3.5562856173340516`*^9}}]
},
WindowSize->{1264, 825},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
FrontEndVersion->"8.0 for Microsoft Windows (32-bit) (November 7, 2010)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[557, 20, 7712, 170, 692, "Input"],
Cell[8272, 192, 4112, 103, 492, "Input"]
}
]
*)

(* End of internal cache information *)
