(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[      4806,        132]
NotebookOptionsPosition[      4564,        119]
NotebookOutlinePosition[      4907,        134]
CellTagsIndexPosition[      4864,        131]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{"C\[AAcute]lculo", " ", "del", " ", "vector", " ", "de", " ", 
    RowBox[{"probabilidades", ".", "\[IndentingNewLine]", "Cada"}], " ", 
    "componente", " ", "i", " ", "del", " ", "vector", " ", "nos", " ", "da", 
    " ", "la", " ", "probabilidad", " ", "Pr", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"W", "=", "i"}], ")"}], ".", "\[IndentingNewLine]", "Se"}], " ",
     "inlcuye", " ", "la", " ", "opci\[OAcute]n", " ", "de", " ", "exportar", 
    " ", "los", " ", "resultados", " ", "a", " ", "un", " ", "fichero", " ", 
    RowBox[{"externo", "."}]}], "*)"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"ClearAll", "[", 
    RowBox[{
    "T", ",", "m", ",", "k", ",", "tope", ",", "prob", ",", 
     "vectorProbabilidad", ",", "f", ",", "t"}], "]"}], "\[IndentingNewLine]",
    "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"T", "=", "120"}], ";"}], " ", 
   RowBox[{"(*", 
    RowBox[{"tama\[NTilde]o", " ", "de", " ", "la", " ", "serie"}], "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"m", "=", "4"}], ";"}], " ", 
   RowBox[{"(*", 
    RowBox[{"dimensi\[OAcute]n", " ", "de", " ", "inmersi\[OAcute]n"}], 
    "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"k", "=", 
     RowBox[{"IntegerPart", "[", 
      RowBox[{"T", "/", "m"}], "]"}]}], ";"}], " ", 
   RowBox[{"(*", 
    RowBox[{
    "n\[UAcute]mero", " ", "de", " ", "ventanas", " ", "deslizantes"}], 
    "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"tope", "=", 
     RowBox[{"Min", "[", 
      RowBox[{
       RowBox[{"m", "!"}], ",", "k"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"prob", "[", 
      RowBox[{"k_", ",", "m_", ",", "t_"}], "]"}], ":=", 
     RowBox[{"N", "[", 
      RowBox[{
       RowBox[{"StirlingS2", "[", 
        RowBox[{"k", ",", "t"}], "]"}], "*", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"(", 
           RowBox[{"m", "!"}], ")"}], "!"}], "/", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"m", "!"}], "-", "t"}], ")"}], "!"}]}], ")"}], "*", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"1", "/", 
          RowBox[{"m", "!"}]}], ")"}], "^", "k"}]}], "]"}]}], ";"}], " ", 
   RowBox[{"(*", 
    RowBox[{"funci\[OAcute]n", " ", "de", " ", "probabilidad"}], "*)"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"vectorProbabilidad", "=", 
     RowBox[{"Array", "[", 
      RowBox[{"f", ",", 
       RowBox[{"{", "tope", "}"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"For", "[", 
     RowBox[{
      RowBox[{"t", "=", "1"}], ",", 
      RowBox[{"t", "\[LessSlantEqual]", "tope"}], ",", 
      RowBox[{"t", "++"}], ",", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"f", "[", "t", "]"}], "=", 
        RowBox[{"prob", "[", 
         RowBox[{"k", ",", "m", ",", "t"}], "]"}]}], ";"}]}], 
     "\[IndentingNewLine]", "]"}], ";"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{
   "(", "\"\<Vector de los valores de la funci\[OAcute]n de probabilidad\>\"",
     ")"}], "\[IndentingNewLine]", "vectorProbabilidad"}]}]], "Input",
 CellChangeTimes->{{3.5403030898847685`*^9, 3.5403031353588486`*^9}, {
  3.5403032746670933`*^9, 3.5403032889411182`*^9}, {3.540303386082489*^9, 
  3.540303534407549*^9}, {3.5403037575347414`*^9, 3.5403037577063417`*^9}, {
  3.540303855534113*^9, 3.540303879214955*^9}, {3.540303952035883*^9, 
  3.540304008710782*^9}, {3.5403053859372067`*^9, 3.5403053892132125`*^9}, {
  3.5403054690709534`*^9, 3.5403055123454294`*^9}, {3.5403871713610277`*^9, 
  3.540387180268644*^9}, {3.5523895973469467`*^9, 3.552389600360512*^9}, {
  3.5524797322780104`*^9, 3.5524797339139004`*^9}, {3.552479798348511*^9, 
  3.552479810565728*^9}, {3.556285484227438*^9, 3.5562854900377703`*^9}, {
  3.5562855594957433`*^9, 3.556285565311076*^9}}]
},
WindowSize->{1264, 825},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
FrontEndVersion->"8.0 for Microsoft Windows (32-bit) (November 7, 2010)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[557, 20, 4003, 97, 412, "Input"]
}
]
*)

(* End of internal cache information *)
