(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[      8576,        195]
NotebookOptionsPosition[      8333,        182]
NotebookOutlinePosition[      8676,        197]
CellTagsIndexPosition[      8633,        194]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{
    "C\[AAcute]lculo", " ", "del", " ", "vector", " ", "cuyas", " ", 
     "componentes", " ", "son", " ", "los", " ", "valores", " ", "del", " ", 
     "n\[UAcute]mero", " ", "de", " ", "permutaciones", " ", "diferentes"}], 
    ",", " ", 
    RowBox[{
    "a", " ", "partir", " ", "de", " ", "los", " ", "que", " ", "hay", " ", 
     "una", " ", "probabilidad", " ", "mayor", " ", "o", " ", "igual", " ", 
     "a", " ", 
     RowBox[{"Nconfianza", "/", "100"}], " ", "de", " ", "encontrar", " ", 
     "el", " ", "valor", " ", "del", " ", "estad\[IAcute]stico", " ", "de", 
     " ", "contraste", " ", 
     RowBox[{"(", 
      RowBox[{
      "bajo", " ", "la", " ", "suposici\[OAcute]n", " ", "de", " ", "que", 
       " ", "la", " ", "serie", " ", "temporal", " ", "proceda", " ", "de", 
       " ", "un", " ", "conjunto", " ", "de", " ", "variables", " ", 
       "aleatorias", " ", 
       RowBox[{"iid", "."}]}], ")"}], "\[IndentingNewLine]", "Cada", " ", 
     "componente", " ", "i", " ", "del", " ", "vector", " ", "se", " ", 
     "corresponde", " ", "con", " ", "una", " ", "serie", " ", "temporal", 
     " ", "de", " ", "tama\[NTilde]o", " ", "igual", " ", "a", " ", "m", "*", 
     RowBox[{"i", ".", "\[IndentingNewLine]", "Se"}], " ", "incluye", " ", 
     "la", " ", "opci\[OAcute]n", " ", "de", " ", "exportar", " ", "los", " ",
      "resultados", " ", "a", " ", "un", " ", "fichero", " ", 
     RowBox[{"externo", "."}]}]}], "*)"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"ClearAll", "[", 
    RowBox[{
    "m", ",", "Nconfianza", ",", "tope", ",", "prob", ",", "vectorVcriticos", 
     ",", "k", ",", "t", ",", "suma"}], "]"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"m", "=", "3"}], ";"}], " ", 
   RowBox[{"(*", 
    RowBox[{"dimensi\[OAcute]n", " ", "de", " ", "inmersi\[OAcute]n"}], 
    "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Nconfianza", "=", "95"}], ";"}], " ", 
   RowBox[{"(*", 
    RowBox[{"nivel", " ", "de", " ", "confianza"}], "*)"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"tope", "=", 
     RowBox[{"Min", "[", 
      RowBox[{
       RowBox[{"m", "!"}], ",", "k"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"prob", "[", 
      RowBox[{"k_", ",", "m_", ",", "t_"}], "]"}], ":=", 
     RowBox[{"N", "[", 
      RowBox[{
       RowBox[{"StirlingS2", "[", 
        RowBox[{"k", ",", "t"}], "]"}], "*", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"(", 
           RowBox[{"m", "!"}], ")"}], "!"}], "/", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"m", "!"}], "-", "t"}], ")"}], "!"}]}], ")"}], "*", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"1", "/", 
          RowBox[{"m", "!"}]}], ")"}], "^", "k"}]}], "]"}]}], ";"}], " ", 
   RowBox[{"(*", 
    RowBox[{"funci\[OAcute]n", " ", "de", " ", "probabilidad"}], "*)"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"vectorVcriticos", "=", 
     RowBox[{"{", "1", "}"}]}], ";"}], " ", 
   RowBox[{"(*", 
    RowBox[{"vector", " ", "de", " ", "valores", " ", "cr\[IAcute]ticos"}], 
    "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"k", "=", "2"}], ";"}], " ", 
   RowBox[{"(*", 
    RowBox[{
    "n\[UAcute]mero", " ", "de", " ", "ventanas", " ", "deslizantes"}], 
    "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"t", "=", "1"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"While", "[", 
     RowBox[{
      RowBox[{"t", "<", 
       RowBox[{"m", "!"}]}], ",", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"suma", "=", "0"}], ";", "\[IndentingNewLine]", 
       RowBox[{"For", " ", "[", 
        RowBox[{
         RowBox[{"t", "=", "tope"}], ",", 
         RowBox[{"t", "\[GreaterSlantEqual]", "1"}], ",", 
         RowBox[{"t", "--"}], ",", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"suma", "=", 
           RowBox[{"suma", "+", 
            RowBox[{"prob", "[", 
             RowBox[{"k", ",", "m", ",", "t"}], "]"}]}]}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{"suma", "\[GreaterSlantEqual]", 
             RowBox[{"Nconfianza", "/", "100"}]}], ",", 
            RowBox[{"Break", "[", "]"}]}], "]"}]}]}], "\[IndentingNewLine]", 
        "]"}], ";", "\[IndentingNewLine]", 
       RowBox[{"vectorVcriticos", "=", 
        RowBox[{"Append", "[", 
         RowBox[{"vectorVcriticos", ",", "t"}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"k", "=", 
        RowBox[{"k", "+", "1"}]}], ";"}]}], "\[IndentingNewLine]", "]"}], 
    ";"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"(", "\"\<Vector de valores cr\[IAcute]ticos\>\"", ")"}], 
   "\[IndentingNewLine]", "vectorVcriticos"}]}]], "Input",
 CellChangeTimes->{{3.5123679119827957`*^9, 3.5123679455228543`*^9}, {
   3.51236797728451*^9, 3.512367998687748*^9}, 3.512368213484525*^9, {
   3.5123682486157866`*^9, 3.512368249161788*^9}, {3.5123683236675186`*^9, 
   3.512368353650771*^9}, {3.5123684169556828`*^9, 3.512368430012905*^9}, {
   3.5123686911417637`*^9, 3.512368699206978*^9}, {3.512368747395463*^9, 
   3.5123687969411497`*^9}, {3.51236883687722*^9, 3.5123688637716675`*^9}, {
   3.5123689096669483`*^9, 3.5123689108369503`*^9}, {3.5123691257429276`*^9, 
   3.5123691651641965`*^9}, {3.5123706629228272`*^9, 
   3.5123706778988533`*^9}, {3.5123707560393906`*^9, 
   3.5123707639486046`*^9}, {3.512370816629897*^9, 3.512370838111135*^9}, {
   3.5123709053784533`*^9, 3.512370917062874*^9}, {3.512370962536954*^9, 
   3.5123710234082603`*^9}, {3.512371145868476*^9, 3.512371146664077*^9}, 
   3.512371235568633*^9, {3.512371325970792*^9, 3.5123713262515926`*^9}, {
   3.51237191082422*^9, 3.5123720226608167`*^9}, {3.5123721140457773`*^9, 
   3.512372119848987*^9}, 3.5123721797998924`*^9, {3.512372209923546*^9, 
   3.5123722156643553`*^9}, {3.512372251092018*^9, 3.512372255756426*^9}, {
   3.512372325566549*^9, 3.5123723390449724`*^9}, {3.5123724436899557`*^9, 
   3.512372448120364*^9}, {3.5123724905212383`*^9, 3.5123724969484496`*^9}, {
   3.512372545558135*^9, 3.5123725601441607`*^9}, {3.512373764419476*^9, 
   3.5123737773050985`*^9}, {3.512374286193592*^9, 3.5123742925272036`*^9}, 
   3.527972555064414*^9, {3.5374055231499853`*^9, 3.5374055312932*^9}, {
   3.5374055822116895`*^9, 3.537405603661727*^9}, {3.5374058761942053`*^9, 
   3.5374059166450768`*^9}, {3.5374061236106405`*^9, 3.537406149569086*^9}, {
   3.537406182079543*^9, 3.537406309032566*^9}, {3.5374063456614304`*^9, 
   3.5374063982491226`*^9}, {3.5374064345815864`*^9, 3.537406494766492*^9}, 
   3.537446539942178*^9, {3.5399082195271416`*^9, 3.5399082233647485`*^9}, {
   3.539908295265275*^9, 3.5399083075892963`*^9}, {3.539908384542632*^9, 
   3.539908388208639*^9}, {3.540040570588414*^9, 3.540040570822415*^9}, {
   3.5400406408353376`*^9, 3.540040704109049*^9}, {3.540040763638753*^9, 
   3.5400407650895557`*^9}, {3.5400408468492994`*^9, 3.540040923554634*^9}, {
   3.5400421352859783`*^9, 3.5400421360347795`*^9}, {3.540042178638454*^9, 
   3.5400422063909025`*^9}, {3.54004469964666*^9, 3.5400447233587017`*^9}, {
   3.5400447832472067`*^9, 3.540044856411335*^9}, {3.540299713708438*^9, 
   3.5402997241292562`*^9}, {3.540300454228939*^9, 3.5403005057402296`*^9}, {
   3.54030055726712*^9, 3.5403005620563283`*^9}, {3.540300633956855*^9, 
   3.5403006559840937`*^9}, {3.5403032309090157`*^9, 
   3.5403032568986616`*^9}, {3.540303772151967*^9, 3.540303825956461*^9}, 
   3.55234028356863*^9, {3.55628552656686*^9, 3.556285543125807*^9}}]
},
WindowSize->{1264, 825},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
FrontEndVersion->"8.0 for Microsoft Windows (32-bit) (November 7, 2010)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[557, 20, 7772, 160, 592, "Input"]
}
]
*)

(* End of internal cache information *)
